#include "blankapp.h"
#include "blankthread.h"

BlankApp::BlankApp( BString aAppSig, BString aDoorSig )
	: BeBSDoorKit( aAppSig, aDoorSig )
{
	// All initialization for the door is handled in the BeBSDoorKit class.
	// All initialization for a given user is handled in the BeBSDoorThread subclass,
	// in this case BlankThread.
}

BlankApp::~BlankApp()
{
	// All cleanup is handled in the BeBSDoorKit.
}

void BlankApp::MessageReceived( BMessage* message )
{
	// There shouldn't be a reason for you to accept messages to this app, but
	// just in case you do, you can modify this as needed.
	BeBSDoorKit::MessageReceived( message );
}

void BlankApp::StartDoor( BMessage* message )
{
	// This function is called whenever a new user joins the board.
	BlankThread* theBlankThread;
	
	// Spawn a new userthread.  The doorSig is passed through the BeBSDoorKit
	// constructor.  In this case, it's ".BlankDoor".  It makes it easy for you
	// to recognize which thread goes with which door, and ensures that there isn't
	// a naming conflict between the user's thread in BeBS and the user's thread in
	// your door.
	theBlankThread = new BlankThread( message->FindString( "UserName" ), doorSig );
	
	// BeBSDoorKit's StartDoor() function does some additional bookkeeping.
	BeBSDoorKit::StartDoor( message );
}

int main( void )
{
	// XXX: Modify the below to reflect the actual name of your door.
	BlankApp theDoor( "application/x-vnd.BeBS.BlankApp", ".BlankDoor" );
	theDoor.Run();
	return 0;
}