#include <OS.h>

#include "blankthread.h"
#include "messages.h"

BlankThread::BlankThread( BString aUserName, BString aDoorSig )
	: BeBSDoorThread( aUserName, aDoorSig )
{
	thread_id theID;

	// Copy in the username so we have it to use later
	theUserName = aUserName;

	// add the door's identifier
	aUserName += aDoorSig;

	// actually launch the user's dedicated thread
	theID = spawn_thread( Run, aUserName.String(), B_NORMAL_PRIORITY, (void*)this );
	resume_thread( theID );
}

BlankThread::~BlankThread()
{
	// All cleanup should occur below, as the destructor isn't guaranteed to be called if
	// this thread is killed.
}

void BlankThread::RunDoor()
{
	isRunning = true;

	// XXX: Send off a welcome message
	SendString( "\nWelcome to Blank Door!" );

//	Setup
	// XXX: Load any user data you might need and do any initialization.

	// This is our main loop
	while( isRunning )
	{
// Main loop
		// XXX: Personally, I find it useful to save the user's data files in the main loop,
		// just in case they disconnect in the middle of things (to prevent data loss).

		// XXX: This is where the meat of the door goes.  You'll probably want to keep this
		// function simple, and add additional functions that do all the work, just to
		// keep things neat.

		// This is a blank door, so do nothing.
		
		// When you want to quit the door, simply do this to end the loop and begin your exit:
		isRunning = false;
	}

	// XXX: Save any files you need to
	
	// XXX: Send off a goodbye message
	SendString( "\nThanks for using Blank Door!" );
	
// Goodbye, cruel world!
	// This closes the door and kills off this thread.  CloseDoor will notify the DoorApp portion
	// that we've finished up.  Once BeBS notices that we're not here anymore, it'll continue on
	// as normal.
	CloseDoor();
	exit_thread( 0 );	
}