#include <stdlib.h>
#include <File.h>

#include "monster.h"

CMonster::CMonster()
{
	theName = "";
	theAttack = "";
	theStr = 0;
	theDef = 0;
	theXP = 0;
	theGold = 0;
	theHP = 0;
}

CMonster::~CMonster()
{
}

BString CMonster::GetName()
{
	return theName;
}

BString CMonster::GetAttack()
{
	return theAttack;
}

int CMonster::GetStr()
{
	return theStr;
}

int CMonster::GetDef()
{
	return theDef;
}

int CMonster::GetXP()
{
	return theXP;
}

int CMonster::GetGold()
{
	return theGold;
}

int CMonster::IsHitBy( int plStr )
{
	int temp;
	
	temp = ( rand() % plStr ) - ( rand() % theDef );
	
	if( temp < 0 )
		temp = 0;

	if( temp != 0 )
		temp = rand() % temp;

	theHP -= temp;

	return temp;
}

int CMonster::GetHP()
{
	return theHP;
}

void CMonster::GetMonster( int level )
{
	int randNum;
	BFile theFile( "/boot/home/BeBS/doors/scary/monsters", B_READ_ONLY );
	char tempChar;
	BString tempString;
	int i;

	// is this the Big Boss?
	if( level == -1 )
	{
		theName = "Giant Scary Beastie";
		theAttack = "Giant Scary Attack";
		theStr = 20000;
		theDef = 20000;
		theXP = 1;
		theGold = 1;
		theHP = 30000;
		theFile.Unset();
		return;
	}

	i = rand() % 100;
	if( (i < 5) && (level > 1) )
	{
		GetMonster( level - 1 );
		theFile.Unset();
		return;
	}
	
	if( (i > 97) && (level < 10) )
	{
		GetMonster( level + 1 );
		theFile.Unset();
		return;
	}

	// Is it a special event?
	i = rand() % 15;
	if( i == 0 )
	{
		theName = "***SPECIAL EVENT***";
		theFile.Unset();
		return;
	}

	// find the appropriate level's monster list
	for( i = 0; i < level; i++ )
	{
		tempChar = '\0';
		while( tempChar != '#' )
		{
			theFile.Read( (void*)&tempChar, sizeof( char ) );
		}
	}

	// get the number of monsters		
	tempString = "";
	tempChar = '\0';
	while( tempChar != '\n' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		tempString += tempChar;
	}

	randNum = atol( tempString.String() );
	randNum = rand() % randNum;
	
	// get the appropriate line
	for( i = 0; i < randNum; i++ )
	{
		tempChar = '\0';
		while( tempChar != '\n' )
			theFile.Read( (void*)&tempChar, sizeof( char ) );
	}
	
	// get the name
	theName = "";
	tempChar = '\0';
	while( tempChar != ',' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		if( tempChar != ',' )
			theName += tempChar;
	}
	
	// get the attack
	theAttack = "";
	tempChar = '\0';
	while( tempChar != ',' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		if( tempChar != ',' )
			theAttack += tempChar;
	}

	// get the HP
	tempString = "";
	tempChar = '\0';
	while( tempChar != ',' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		if( tempChar != ',' )
			tempString += tempChar;
	}
	theHP = atol( tempString.String() );
	
	// get the Str
	tempString = "";
	tempChar = '\0';
	while( tempChar != ',' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		if( tempChar != ',' )
			tempString += tempChar;
	}
	theStr = atol( tempString.String() );
	
	// get the Def
	tempString = "";
	tempChar = '\0';
	while( tempChar != ',' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		if( tempChar != ',' )
			tempString += tempChar;
	}
	theDef = atol( tempString.String() );
	
	// get the XP
	tempString = "";
	tempChar = '\0';
	while( tempChar != ',' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		if( tempChar != ',' )
			tempString += tempChar;
	}
	theXP = atol( tempString.String() );
	
	// get the Gold
	tempString = "";
	tempChar = '\0';
	while( tempChar != '\n' )
	{
		theFile.Read( (void*)&tempChar, sizeof( char ) );
		if( tempChar != '\n' )
			tempString += tempChar;
	}
	theGold = atol( tempString.String() );
	
	theFile.Unset();
}