#include <File.h>
#include <stdlib.h>
#include <math.h>
#include <OS.h>

#include "player.h"

CPlayer::CPlayer()
{
	time_t timer;
	char buffer[9999] = { '\0' };
	
	theLocation = "Town";
	thePlayerName = "";
	theGold = 0;
	theHP = 10;
	theMaxHP = 10;
	theLevel = 1;
	theStr = 7;
	theDef = 7;
	theXP = 0;
	theCaveLevel = 1;
	theFights = 15;
	theWeapon = "Moderately Sharp Playing Card";
	theArmor = "T-Shirt and Jeans";
	theWeaponStr = 1;
	theArmorStr = 1;

	timer = real_time_clock();
	strftime( buffer, 9999, "%Y%m%d", localtime( &timer ) );
	theDate = atol( buffer );
}

CPlayer::~CPlayer()
{
}

void CPlayer::SetLocation( BString loc )
{
	theLocation = loc;
}

BString CPlayer::GetLocation()
{
	return theLocation;
}

bool CPlayer::LoadPlayer( BString name )
{
	BFile* theFile;
	BString tempString("");
	char buffer[9999] = { '\0' };
	time_t timer;
	int tempDate;
	char tempChar;

	tempString = "/boot/home/BeBS/doors/scary/users/";
	tempString += name;
	
	theFile = new BFile( tempString.String(), B_READ_ONLY );

	if( theFile->InitCheck() == B_OK )
	{
		// read thePlayerName
		thePlayerName = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				thePlayerName += tempChar;
		}
		// read the Weapon
		theWeapon = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				theWeapon += tempChar;
		}
		// read the Armor
		theArmor = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				theArmor += tempChar;
		}
		// read the WeaponStr
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theWeaponStr = atoi( tempString.String() );
		// read the ArmorStr
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theArmorStr = atoi( tempString.String() );
		// read the gold
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theGold = atoi( tempString.String() );
		// read the maxHP
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theMaxHP = atoi( tempString.String() );
		// read the HP
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theHP = atoi( tempString.String() );
		// read the Level
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theLevel = atoi( tempString.String() );
		// read the XP
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theXP = atoi( tempString.String() );
		// read the STR
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theStr = atoi( tempString.String() );
		// read the DEF
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theDef = atoi( tempString.String() );
		// read theFights
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theFights = atoi( tempString.String() );
		// read the date
		tempString = "";
		tempChar = 0;
		while( tempChar != '\n' )
		{
			theFile->Read( (void*)&tempChar, sizeof( char ) );
			if( tempChar != '\n' )
				tempString += tempChar;
		}
		theDate = atoi( tempString.String() );

		timer = real_time_clock();
		strftime( buffer, 9999, "%Y%m%d", localtime( &timer ) );
		tempDate = atol( buffer );

		if( theDate < tempDate )
		{
			// it's a new day!
			theHP = theMaxHP;
			theFights = 15;
			theDate = tempDate;
		}

		theFile->Unset();
		delete theFile;
		return true;
	}

	theFile->Unset();
	delete theFile;
	return false;	
}

void CPlayer::SavePlayer( BString name )
{
	size_t stringSize;
	BFile* theFile;
	BString tempString("");

	tempString = "/boot/home/BeBS/doors/scary/users/";
	tempString += name;

	theFile = new BFile( tempString.String(), B_WRITE_ONLY | B_ERASE_FILE | B_CREATE_FILE );

	if( theFile->InitCheck() == B_OK )
	{
		// write thePlayerName
		tempString = thePlayerName;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write theWeapon
		tempString = theWeapon;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write theArmor
		tempString = theArmor;
		tempString << "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the weaponstr
		tempString = "";
		tempString << theWeaponStr;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the armorstr
		tempString = "";
		tempString << theArmorStr;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the gold
		tempString = "";
		tempString << theGold;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the maxHP
		tempString = "";
		tempString << theMaxHP;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the HP
		tempString = "";
		tempString << theHP;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the Level
		tempString = "";
		tempString << theLevel;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the XP
		tempString = "";
		tempString << theXP;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the STR
		tempString = "";
		tempString << theStr;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the DEF
		tempString = "";
		tempString << theDef;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the fights
		tempString = "";
		tempString << theFights;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
		// write the date
		tempString = "";
		tempString << theDate;
		tempString += "\n";
		stringSize = tempString.Length();
		theFile->Write( (void*)(tempString.String()), stringSize );
	}

	theFile->Unset();
	delete theFile;
}

void CPlayer::SetName( BString name )
{
	thePlayerName = name;
}

BString CPlayer::GetName()
{
	return thePlayerName;
}

int CPlayer::GetBalance()
{
	return theGold;
}

void CPlayer::AddGold( int gold )
{
	theGold += gold;
}

bool CPlayer::SpendGold( int gold )
{
	if( gold <= theGold )
	{
		theGold -= gold;
		return true;
	}
	
	return false;
}

int CPlayer::Heal( int hp )
{
	int diff;
	int healed;
	
	diff = theMaxHP - theHP;
	
	if( hp > diff )
		healed = diff;
	else
		healed = hp;
		
	theHP += healed;
	
	return healed;
}

bool CPlayer::Damaged( int hp )
{
	theHP -= hp;
	
	if( theHP <= 0 )
		return false;
	
	return true;
}

int CPlayer::GetMaxHP()
{
	return theMaxHP;
}

int CPlayer::GetHP()
{
	return theHP;
}

int CPlayer::GetLevel()
{
	return theLevel;
}

int CPlayer::GetXP()
{
	return theXP;
}

bool CPlayer::AddXP( int xp )
{
	theXP += xp;
	if( theXP > pow( 2, (theLevel + 4) ) )
	{
		LevelUp();
		return true;
	}
	
	return false;
}

void CPlayer::LevelUp()
{
	// gain a level
//	theMaxHP += 5 * theLevel;
	theMaxHP = int(theMaxHP * 1.5);
//	theHP += 5 * theLevel;
	theHP = int(theHP * 1.5);
	theStr += theLevel;
	theDef += theLevel;
	
	theLevel++;
}

int CPlayer::GetStr()
{
	return theStr;
}

int CPlayer::GetDef()
{
	return theDef;
}

void CPlayer::AddStr( int add )
{
	theStr += add;
}

void CPlayer::AddDef( int add )
{
	theDef += add;
}

void CPlayer::GoUp()
{
	theCaveLevel--;
	if( theCaveLevel < 1 )
		theCaveLevel = 1;
}

void CPlayer::GoDown()
{
	theCaveLevel++;
	if( theCaveLevel > 10 )
		theCaveLevel = 10;
}

int CPlayer::GetCaveLevel()
{
	return theCaveLevel;
}

bool CPlayer::Fights()
{
	theFights--;
	if( theFights < 0 )
	{
		theFights = 0;
		return false;
	}

	return true;
}

int CPlayer::IsHitBy( int monStr )
{
	int temp;
	int armor;
	
	armor = (int)pow( 2, theArmorStr );

	temp = ( rand() % monStr ) - ( rand() % theDef ) - ( rand() % armor );
	
	if( temp < 0 )
		temp = 0;

	if( temp != 0 )
		temp = rand() % temp;

	theHP -= temp;

	return temp;
}

int CPlayer::GetFights()
{
	return theFights;
}

void CPlayer::SetWeapon( BString name, int sel )
{
	theWeapon = name;
	theWeaponStr = sel;
}

void CPlayer::SetArmor( BString name, int sel )
{
	theArmor = name;
	theArmorStr = sel;
}

BString CPlayer::GetWeapon()
{
	return theWeapon;
}

BString CPlayer::GetArmor()
{
	return theArmor;
}

int CPlayer::GetWeaponStr()
{
	return theWeaponStr;
}

int CPlayer::GetArmorStr()
{
	return theArmorStr;
}

void CPlayer::AddFights( int fights )
{
	theFights += fights;
}